
USE 34
JOIN 33 INTO CODNUM==CODNUM ANNO==ANNO PROVV==PROVV NDOC==NDOC
JOIN 17 TO 33 INTO TIPOCF==TIPOCF CODCF==CODCF
JOIN 20 TO 33 INTO TIPOCF==TIPOCF CODCF==CODCF
JOIN 16 TO 33 INTO TIPOCF==TIPOCF CODCF==CODCF CODIND==CODINDSP
JOIN 16 TO 17 ALIAS 116 INTO TIPOCF==TIPOCF CODCF==CODCF CODIND==CODINDSP
JOIN 47 INTO CODART==CODART
JOIN %CPG TO 33 ALIAS 201 INTO CODTAB==CODPAG
JOIN %AGE TO 33 ALIAS 202 INTO CODTAB==CODAG
JOIN %POR TO 33 ALIAS 203 INTO CODTAB==CODPORTO
JOIN %BAN TO 33 ALIAS 204 INTO CODTAB==CODABIA+CODCABA
JOIN %VET TO 33 ALIAS 205 INTO CODTAB==CODVETT1
JOIN %ASP TO 33 ALIAS 206 INTO CODTAB==ASPBENI1

END
DESCRIPTION
BEGIN
  34->* "Righe documenti di vendita"
  33->* "Documenti di vendita"
  17->* "Clienti/Fornitori per vendite"
  20->* "Clienti/Fornitori"
  16->* "Indirizzi di spedizione (destinazione)"
  116@->* "Indirizzi di spedizione (destinatario)"
  47->* "Anagrafica magazzino"
  201@->* "Tabella condizioni di pagamento"
  202@->* "Tabella agenti"
  203@->* "Tabella porto"
  204@->* "Tabella banche"
  205@->* "Tabella vettori"
  206@->* "Tabella apsetto beni"
END

GENERAL
BEGIN
  OFFSET 0 0
  FONT "Courier New"
  SIZE 12
  MODULE BUFFETTI_BOLLA_01
END

SECTION HEADER ODD 33

STRING 1 36 1
BEGIN
 KEY "nome ditta"
 PROMPT 5 6 ""
 MESSAGE _DITTA,!RAGSOC
END

STRING 2 36 1
BEGIN
 KEY "indirizzo ditta"
 PROMPT 5 7 ""
 MESSAGE _DITTA,!IND
END

STRING 3 5 1
BEGIN
 KEY "cap ditta"
 PROMPT 5 8 ""
 MESSAGE _DITTA,!CAP
END

STRING 4 30 1
BEGIN
 KEY "comune ditta"
 PROMPT 12 8 ""
 MESSAGE _DITTA,!COM
END

STRING 5 5 1
BEGIN
 KEY "scritta P.IVA"
 PROMPT 5 9 "P.IVA"
END

STRING 6 16 1
BEGIN
 KEY "partita iva ditta"
 PROMPT 11 9 ""
 MESSAGE _DITTA,!IVA
END

STRING 7 9 1
BEGIN
 KEY "scritta COD.FISC."
 PROMPT 5 10 "COD.FISC."
END

STRING 8 16 1
BEGIN
 KEY "codice fiscale ditta"
 PROMPT 15 10 ""
 MESSAGE _DITTA,!CF
END

STRING 14 35 2
BEGIN
 KEY "destinatario, ditta"
 PROMPT 44 16 ""
 FIELD 20->RAGSOC
END

STRING 15 35 2
BEGIN
 KEY "destinatario, indirizzo"
 PROMPT 44 18 ""
 FIELD 20->INDCF
END

STRING 48 5 1
BEGIN
 KEY ""
 PROMPT 1 1 ""
 FLAGS "H"
 FIELD 116@->COM
END

STRING 16 5 1
BEGIN
 KEY "destinatario, cap"
 PROMPT 44 20 ""
 MESSAGE _ISAMREAD,13,COM==#48,CAPCOM
END

STRING 17 30 2
BEGIN
 KEY "destinatario, comune"
 PROMPT 50 20 ""
 MESSAGE _ISAMREAD,13,COM==#48,DENCOM
END

STRING 18 2 1
BEGIN
 KEY "destinatario, procincia"
 PROMPT 72 21 ""
 MESSAGE _ISAMREAD,13,COM=#48,PROVCOM
END

DATE 19 8 1
BEGIN
 KEY "data bolla"
 PROMPT 60 25 ""
 FIELD 33->DATADOC
 FORMAT "1442-"
END

NUMBER 20
BEGIN
 KEY "numero bolla"
 PROMPT 71 25 ""
 FIELD 33->NDOC
END

STRING 21 30 2
BEGIN
 KEY "destinazione, indirizzo"
 PROMPT 5 16 ""
 FIELD 16->INDIR
END

STRING 32 5 1
BEGIN
 KEY "destinazione, cap"
 PROMPT 5 18 ""
 FIELD 16->CAP
END

STRING 49 5 1
BEGIN
 KEY ""
 PROMPT 1 1 ""
 FLAGS "H"
 FIELD 16->COM
END

STRING 33 21 1
BEGIN
 KEY "destinazione, comune"
 PROMPT 5 20 ""
 MESSAGE _ISAMREAD,13,COM=#49,DENCOM
END

STRING 34 2
BEGIN
 KEY "destinazione, provincia"
 PROMPT 28 20 ""
 MESSAGE _ISAMREAD,13,COM=#49,PROVCOM
END

NUMBER 22
BEGIN
 KEY "ordine"
 PROMPT 3 25 ""
 FIELD 33->NUMDOCRIF
END

DATE 23 8 1
BEGIN
 KEY "data conferma"
 PROMPT 16 25 ""
 FIELD 33->DATADOCRIF
 FORMAT "1442-"
END

STRING 24 48 1
BEGIN
 KEY "condizioni pagamento"
 PROMPT 3 27 ""
 FIELD 201@->S0
END

STRING 25 29 1
BEGIN
 KEY "banca appoggio"
 PROMPT 53 27 ""
 FIELD 204@->S0
END

STRING 26 7 1
BEGIN
 KEY "codice cliente"
 PROMPT 3 29 ""
 FIELD 33->CODCF
END

STRING 27 11 1
BEGIN
 KEY "partita iva cliente"
 PROMPT 12 29 ""
 FIELD 20->PAIV
END

STRING 28 18 1
BEGIN
 KEY "porto"
 PROMPT 41 25 ""
 FIELD 203@->S0
END

NUMBER 29
BEGIN
 KEY "codice agente"
 PROMPT 29 29 ""
 FIELD 33->CODAG
END

STRING 30 28 1
BEGIN
 KEY "nome agente"
 PROMPT 33 29 ""
 FIELD 202@->S0
END

END

SECTION BODY ODD 1

STRING 32 13 1
BEGIN
 KEY "codice articolo"
 PROMPT 5 1 ""
 FIELD 34->CODART
END

STRING 33 30 1
BEGIN
 KEY "descrizione articolo"
 PROMPT 25 1 ""
 FIELD 47->DESCR
END

STRING 34 2 1
BEGIN
 KEY "unit di misura"
 PROMPT 56 1 ""
 FIELD 34->UMQTA
END

NUMBER 35 6 3
BEGIN
 KEY "quantit"
 PROMPT 60 1 ""
 PICTURE "@@@@@@,###"
 FIELD 34->QTA
END

STRING 36 10 1
BEGIN
 KEY "quantit lettere"
 PROMPT 72 1 ""
 MESSAGE _CIFRELETTERE,#35
END

END

SECTION FOOTER ODD 9

STRING 47 5 1
BEGIN
 KEY "scritta SEGUE"
 PROMPT 72 9 "SEGUE"
END

END

SECTION FOOTER LAST 9

LIST 37 1 1
BEGIN
 KEY "trasporto a cura del mittente"
 PROMPT 4 1 ""
 FIELD 33->CODSPMEZZO
 ITEM "|"
 ITEM "D|"
 ITEM "V|"
 ITEM "M|x"
END

LIST 38 1 1
BEGIN
 KEY "trasporto a cura del destinatario"
 PROMPT 13 1 ""
 FIELD 33->CODSPMEZZO
 ITEM "|"
 ITEM "D|x"
 ITEM "V|"
 ITEM "M|"
END

LIST 39 1 1
BEGIN
 KEY "trasporto a cura del vettore"
 PROMPT 23 1 ""
 FIELD 33->CODSPMEZZO
 ITEM "|"
 ITEM "D|"
 ITEM "V|x"
 ITEM "M|"
END

STRING 40 45 1
BEGIN
 KEY "nome vettore"
 PROMPT 3 4 ""
 FIELD 205@->S0
END

STRING 41 45 1
BEGIN
 KEY "indirizzo vettore"
 PROMPT 3 6 ""
 FIELD 205@->S1
END

DATE 42 8 1
BEGIN
 KEY "data inizio trasporto"
 PROMPT 51 3 ""
 FIELD 33->DATAPART
 FORMAT "1442-"
END

STRING 43 5 1
BEGIN
 KEY "ora inizio trasporto"
 PROMPT 60 3 ""
 FIELD 33->ORAPART
END

STRING 44 27 1
BEGIN
 KEY "aspetto beni"
 PROMPT 37 1 ""
 FIELD 206@->S0
END

STRING 45 7 1
BEGIN
 KEY "peso"
 PROMPT 73 1 ""
 FIELD 33->PNETTO
END

STRING 46 5 1
BEGIN
 KEY "colli"
 PROMPT 66 1 ""
 FIELD 33->NCOLLI
END

END

END
