
// - I FIELD sul file 20 (clifo) vanno sostituiti con messaggi _CLIENTE.
// - "Cliente provincia" e' gestito dalla relazione. Dovra' essere gestito da un messaggio _CLIENTE
// - Manca "azzera totalizzatore 1"
// - Completare "iva" nelle righe della fattura
// - Nella coda della fattura, completare i campi che non sono totalizzatori
// - Codici per i totalizzatori:
//   SPTRAS       spese di trasporto
//   SPINC        spese incasso
//   SPIMB        spese imballaggio
//   SPBOL        spese bolli
//   TIMP         totale imponibile
//   TIMPS        totale imposta
//   TESEN        totale esenti
//   IMPNETTO     totale importi netti (stesso codice per il totalizzatore della riga)
//   TFATT        totale fattura
//   NETPAG       netto da pagare
//
// Togliere dalla relazione i files che non servono, quando tutti i campi sono OK.

USE 33
JOIN 34                 INTO CODNUM==CODNUM ANNO==ANNO PROVV==PROVV NDOC==NDOC
JOIN 17                 INTO TIPOCF==TIPOCF CODCF==CODCF
JOIN 20                 INTO TIPOCF==TIPOCF CODCF==CODCF
JOIN 16                 INTO TIPOCF==TIPOCF CODCF==CODCF CODIND==CODINDSP
JOIN 16 TO 17 ALIAS 116 INTO TIPOCF==TIPOCF CODCF==CODCF CODIND==CODINDSP
JOIN 47 TO 34           INTO CODART==CODART
JOIN 52                 INTO TIPOCF==TIPOCF CODCF==CODCF
JOIN 13 TO 20           INTO CAPCOM==CAPCF		// da togliere quando ci saranno i messaggi _CLIENTE
JOIN %CPG               INTO CODTAB==CODPAG
JOIN %AGE               INTO CODTAB==CODAG
JOIN %POR               INTO CODTAB==CODPORTO
JOIN %BAN               INTO CODTAB==CODABIA+CODCABA
JOIN %VET               INTO CODTAB==CODVETT1
JOIN %ASP               INTO CODTAB==ASPBENI1
END

DESCRIPTION
BEGIN
  33->* "Documenti di vendita"
  34->* "Righe documenti di vendita"
  17->* "Clienti/Fornitori per vendite"
  20->* "Clienti/Fornitori"
  47  ->* "Righe listini"
  52  ->* "Contratti clienti"
  16  ->* "Indirizzi di spedizione"
  116->* "Indirizzi di spedizione"
  13->* "Comuni"
  %CPG->* "Condizioni di pagamento"
  %AGE ->* "Agenti"
  %MSP ->* "Modalit di spedizioni"
  %POR ->* "Modalit di consegna"
  %BAN ->* "Banche"
END

GENERAL
BEGIN
   OFFSET 0 0
   FONT "Courier New"
   SIZE 12
END

///////////////////////////////////////////////
SECTION HEADER ODD 28 0 -5

STRINGA 1 35 1
BEGIN
 KEY "nome ditta"
 PROMPT  3 4 ""
 MESSAGE _DITTA 6->RAGSOC
END

STRINGA 2 35 1
BEGIN
 KEY "indirizzo ditta"
 PROMPT  3 5 ""
 MESSAGE _DITTA 6->INDRES
END

STRINGA 3 5 1
BEGIN
 KEY "cap ditta"
 PROMPT  3 6 ""
 MESSAGE _DITTA 6->CAPRES
END

STRINGA 4 30 1
BEGIN
 KEY "comune ditta"
 PROMPT  10 6 ""
 MESSAGE _DITTA 6->DENCOM
END

STRINGA 5 5 1
BEGIN
 KEY "scritta P.IVA"
 PROMPT  3 7 "P.IVA"
END

STRINGA 6 16 1
BEGIN
 KEY "partita iva ditta"
 PROMPT  9 7 ""
 MESSAGE _DITTA 6->PAIV
END

STRINGA 7 9 1
BEGIN
 KEY "scritta COD.FISC."
 PROMPT  3 8 "COD.FISC."
END

STRINGA 8 16 1
BEGIN
 KEY "codice fiscale ditta"
 PROMPT  13 8 ""
 MESSAGE _DITTA-> 6->CODFI
END

NUMERO 9 10 1
BEGIN
 KEY "reg.soc.trib...."
 PROMPT  3 9 "RED.SOC.TRIB.R.E.     "
END

NUMERO 12 10 1
BEGIN
 KEY "c.c.i.a.a. ....."
 PROMPT  3 10 "C.C.I.A.A.       "
END

STRINGA 14 8 1
BEGIN
 KEY "data fattura"
 PROMPT  61 21 ""
 FILED 33->DATADOC
END

STRINGA 15 5 1
BEGIN
 KEY "numero fattura"
 PROMPT  71 21 ""
 FIELD 33->NDOC
END

STRINGA 16 4 1
BEGIN
 KEY "codice cliente"
 PROMPT  3 23 ""
 FIELD 33->CODCF
END

STRINGA 17 2 1
BEGIN
 KEY "codice agente"
 PROMPT  9 23 ""
 FIELD 33->CODAG
END

STRINGA 18 14 1
BEGIN
 KEY "porto"
 PROMPT  52 23 ""
 FIELD 306@->S0
END

NUMERO 19 7 1
BEGIN
 KEY "ordine"
 PROMPT  12 23 ""
 FIELD 33->NUMDOCRIF
END

DATA 20 8 1
BEGIN
 KEY "data conferma"
 PROMPT  20 23 ""
 FIELD DATADOCRIF
 FORMAT "1444-"
END

STRINGA 21 49 1
BEGIN
 KEY "condizioni di pagamento"
 PROMPT  3 25 ""
 FIELD %CPG->S0
END

STRINGA 22 29 1
BEGIN
 KEY "banca d'appoggio"
 PROMPT  54 25 ""
 FIELD 901@->S0
END

STRINGA 23 38 1
BEGIN
 KEY "cliente ragione sociale 1"
 PROMPT  44 11 ""
END

STRINGA 24 38 1
BEGIN
 KEY "cliente ragione sociale 2"
 PROMPT  44 12 ""
END

STRINGA 25 38 1
BEGIN
 KEY "cliente indirizzo 1"
 PROMPT  44 13 ""
END

STRINGA 26 38 1
BEGIN
 KEY "cliente indirizzo 2"
 PROMPT  44 14 ""
END

STRINGA 27 5 1
BEGIN
 KEY "cliente cap"
 PROMPT  44 15 ""
END

STRINGA 28 30 1
BEGIN
 KEY "cliente localita 1"
 PROMPT  50 15 ""
END

STRINGA 30 2 1
BEGIN
 KEY "cliente provincia"
 PROMPT  73 16 ""
 FIELD 13->PROVCOM
END

STRINGA 31 2 1
BEGIN
 KEY "azzera totalizzatore 1"
 PROMPT  73 16 ""
END

END

/////////////////////////////////////////////////
SECTION BODY ODD 22

STRINGA 32 13 1
BEGIN
 KEY "codice articolo"
 PROMPT  2  ""
 FIELD 101@->CODART
END

STRINGA 33 19 1
BEGIN
 KEY "descrizione articolo"
 PROMPT  17  ""
 FIELD 401@->DESCR
END

STRINGA 34 3 1
BEGIN
 KEY "unita' di misura"
 PROMPT  38  ""
END

STRINGA 35 8 1
BEGIN
 KEY "quantita'"
 PROMPT  42  ""
 FIELD 101@->QTA
END

STRINGA 36 10 1
BEGIN
 KEY "prezzo unitario"
 PROMPT  52  ""
END

STRINGA 37 3 1
BEGIN
 KEY "sconto"
 PROMPT  64  ""
END

STRINGA 38 11 1
BEGIN
 KEY "importo netto"
 PROMPT  68  ""
END

STRINGA 39 3 1
BEGIN
 KEY "iva"
 PROMPT  81  ""
END

END

///////////////////////////////////////////////////
SECTION FOOTER ODD 

STRINGA 40 11 1
BEGIN
 KEY "spese di trasporto"
 PROMPT  42 53 ""
END

STRINGA 41 6 1
BEGIN
 KEY "spese di incasso"
 PROMPT  56 63 ""
END

STRINGA 42 11 1
BEGIN
 KEY "spese di imballo"
 PROMPT  56 53 ""
END

STRINGA 43 5 1
BEGIN
 KEY "spese bolli"
 PROMPT  64 63 ""
END

STRINGA 44 11 1
BEGIN
 KEY "imponibile 1"
 PROMPT  7 56 ""
END

STRINGA 45 2 1
BEGIN
 KEY "iva 1"
 PROMPT  20 56 ""
END

STRINGA 46 11 1
BEGIN
 KEY "imposta 1"
 PROMPT  23 56 ""
END

STRINGA 47 11 1
BEGIN
 KEY "imponibile 2"
 PROMPT  7 57 ""
END

STRINGA 48 2 1
BEGIN
 KEY "iva 2"
 PROMPT  20 57 ""
END

STRINGA 49 11 1
BEGIN
 KEY "imposta 2"
 PROMPT  23 57 ""
END

STRINGA 50 11 1
BEGIN
 KEY "imponibile 3"
 PROMPT  7 58 ""
END

STRINGA 51 2 1
BEGIN
 KEY "iva 3"
 PROMPT  20 58 ""
END

STRINGA 52 11 1
BEGIN
 KEY "imposta 3"
 PROMPT  23 58 ""
END

STRINGA 53 11 1
BEGIN
 KEY "imponibile 4"
 PROMPT  7 59 ""
END

STRINGA 54 3 1
BEGIN
 KEY "iva 4"
 PROMPT  2 59 ""
END

STRINGA 55 45 1
BEGIN
 KEY "descrizione altri 4"
 PROMPT  36 59 ""
END

STRINGA 56 11 1
BEGIN
 KEY "imponibile 5"
 PROMPT  7 60 ""
END

STRINGA 57 3 1
BEGIN
 KEY "iva 5"
 PROMPT  2 60 ""
END

STRINGA 58 45 1
BEGIN
 KEY "descrizione altri 5"
 PROMPT  36 60 ""
END

STRINGA 59 12 1
BEGIN
 KEY "totale imponibile"
 PROMPT  6 63 ""
END

STRINGA 60 11 1
BEGIN
 KEY "totale imposta"
 PROMPT  23 63 ""
END

STRINGA 61 9 1
BEGIN
 KEY "totale esenti"
 PROMPT  36 63 ""
END

STRINGA 62 11 1
BEGIN
 KEY "totale importi netti"
 PROMPT  3 53 ""
END

STRINGA 63 12 1
BEGIN
 KEY "totale fattura"
 PROMPT  71 63 ""
END

STRINGA 64 8 1
BEGIN
 KEY "scadenza pagamento 1"
 PROMPT  3 66 ""
END

STRINGA 65 11 1
BEGIN
 KEY "importo scadenza 1"
 PROMPT  15 66 ""
END

STRINGA 66 8 1
BEGIN
 KEY "scadenza pagamento 2"
 PROMPT  3 68 ""
END

STRINGA 67 11 1
BEGIN
 KEY "importo scadenza 2"
 PROMPT  15 68 ""
END

STRINGA 68 8 1
BEGIN
 KEY "scadenza pagamento 3"
 PROMPT  30 68 ""
END

STRINGA 69 11 1
BEGIN
 KEY "importo scadenza 3"
 PROMPT  42 68 ""
END

STRINGA 70 8 1
BEGIN
 KEY "scadenza pagamento 4"
 PROMPT  3 69 ""
END

STRINGA 71 11 1
BEGIN
 KEY "importo scadenza 4"
 PROMPT  15 69 ""
END

STRINGA 72 8 1
BEGIN
 KEY "scadenza pagamento 5"
 PROMPT  30 69 ""
END

STRINGA 73 11 1
BEGIN
 KEY "importo scadenza 5"
 PROMPT  42 69 ""
END

STRINGA 74 10 1
BEGIN
 KEY "anticipo"
 PROMPT  47 66 ""
END

STRINGA 75 12 1
BEGIN
 KEY "netto da pagare"
 PROMPT  71 66 ""
 MESSAGE _COD_TESTA NETPAG
END

END

////////////////////////////////////
SECTION FOOTER LAST 1

STRINGA 76 5 1
BEGIN
 KEY "stampa 'segue' in coda"
 PROMPT  73 70 "segue"
END

END